//
//  HTML PAGE
//
const char PAGE_NarmonSettings[] PROGMEM =  R"=====(
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="Content-type" content="text/html; charset=utf-8">
<title>Led_clock_weath на ESP-12</title>
<body onload="load();">
  <div class="container">
    <div class="row" style="text-align:center;">
      <h1 style="margin:50px;">Настройка подключения к NARODMON.RU</h1>
      <div class="col-sm-offset-2 col-sm-8 col-md-offset-3 col-md-6">
        <div class="alert alert-dismissible alert-warning">
          Если вы желаете получать показания температуры с сайта <a href="http://narodmon.ru" align="center" target="_blank"> narodmon.ru</a>, то выполните настройку подключения.
        </div>
        <hr>
        <div class="row">
          <div class="col-sm-6" style="margin-top">
            <div class="alert alert-dismissible alert-warning"style="padding-top:8px; padding-bottom: 9px;"> 
              API ключ narodmon.ru:
            </div>
          </div>
          <div class="col-sm-6">
            <input id="narodmonKey" value="{{narodmonKey}}" class="form-control" pattern="[0-9a-zA-Z.]{1,32}" placeholder="Ключ narodmon.ru API">
          </div>
        </div>
        <div class="row" >
          <div class="col-sm-6" style="margin-top">
            <div class="alert alert-dismissible alert-warning"style="padding-top:8px; padding-bottom: 9px;">
              UUID для narodmon.ru:
            </div>
          </div>
          <div class="col-sm-6">
            <input id="uuidKey" value="{{uuidKey}}" class="form-control" pattern="[0-9a-zA-Z.]{1,32}" placeholder="UUID для narodmon.ru">
          </div>
        </div>
        <div class="row">
          <div class="col-sm-6" style="margin-top">
            <div class="alert alert-dismissible alert-warning"style="padding-top:8px; padding-bottom: 9px;"> 
              ID датчика:
            </div>
          </div>
          <div class="col-sm-6">
            <input id="sensorKey" value="{{sensorKey}}" class="form-control" pattern="[0-9]{1,16}" placeholder="ID датчика">
          </div>
        </div>
		    <hr>
        Если вы не желаете использовать сервис narodmon.ru , то в поле "ID датчика" введите "0"
        <hr>
		     <a href="http://www.md5.cz/" align="center" target="_blank">Здесь генерируем UUID</a>
         <br /> Также в качестве UUID для <a href="http://narodmon.ru" align="center" target="_blank"> narodmon.ru</a> можно использовать API ключ от <a href="http://openweathermap.org/api" align="center" target="_blank"> openweathermap.org</a>
		     <br /> <a href="http://narodmon.ru" align="center" target="_blank">Здесь берем API ключ и ID датчика</a>
		 <br />
        <input class="btn btn-block btn-success" value="Сохранить" onclick="set_narodmonKey(this);" type="submit">
        <hr>
        <a class="btn btn-block btn-default" href="/">Настройка подключения WiFi</a>
        <a class="btn btn-block btn-default" href="/time.htm">Настройка времени</a>
        <a class="btn btn-block btn-default" href="/weather.htm">Настройка погоды</a>
        <a class="btn btn-block btn-default" href="/mqtt.htm">Настройка MQTT сервера</a>
        <a class="btn btn-block btn-default" href="/led.htm">Настройка дисплея</a>
        <a class="btn btn-block btn-default" href="/update.htm">Обновление прошивки</a>
        <a class="btn btn-block btn-default" href="/help.htm">Помощь</a>
        <input class="btn btn-block btn-danger" value="Перезагрузить устройство" onclick="restart(this,'Вы действительно желаете перезагрузить устройство?');" type="submit">
      </div>
    </div>
  </div>
</body>

<head>
  <link rel="stylesheet" href="/bootstrap.min.css">
  <link rel="stylesheet" type="text/css" href="/style.css">
  <script type="text/javascript" src="/function.js"></script>
  <script type="text/javascript">
    function set_narodmonKey(submit) {
      server = "/narmonUst?narodmonKey="+val('narodmonKey')+"&uuidKey="+val('uuidKey')+"&sensorKey="+val('sensorKey');
      send_request(submit,server);
      alert("Изменения вступят в силу после перезагрузки. Пожалуйста перезагрузите устройство.");
    }
    function restart(submit,texts){
      if(confirm(texts)) {
        server = "/restart?device=ok";
        send_request(submit,server);
        return true;
      } else {
          return false;
      }
    }
  </script>
</head>
)=====";
