//
//  HTML PAGE
//
const char PAGE_UpdateSettings[] PROGMEM =  R"=====(
<meta http-equiv="Content-type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>Led_clock_weath на ESP-12</title>
<body onload="load();">
  <div class="container">
    <div class="row" style="text-align:center;">
      <h1 style="margin:50px;">Обновление прошивки</h1>
      <div class="col-sm-offset-2 col-sm-8 col-md-offset-3 col-md-6">
        <div class="alert alert-dismissible alert-info">
          <b>Обновление: выберите и загрузите файл прошивки (bin)</b>
          <form method="POST" action="/update" enctype="multipart/form-data">
            <div class="btn-group">
              <input type="file" class="btn btn-primary btn-xs" name="update" style="height: 33px;">
              <input type="submit" class="btn btn-default btn-sm" value="Загрузить" onclick="this.value='Подождите...';" style="height: 33px;">
            </div>
          </form>
        </div>
        <hr>
        <div class="alert alert-dismissible alert-info">
          <b style="text-align:center;">Возможность обновления прошивки по OTA </b>
          <div>
            <b style="height: 33px;">Статус OTA:  </b>
            <input id="updateOTA" value="{{updateOTA}}" pattern="[0-1]{1,1}" class="form-control">
          </div>
          <input class="btn btn-block btn-success" value="Сохранить" onclick="set_updateOtta(this);" type="submit">
        </div>
        <hr>     
        <a class="btn btn-block btn-default" href="/">Настройка подключения WiFi</a>
        <a class="btn btn-block btn-default" href="/time.htm">Настройка времени</a>
        <a class="btn btn-block btn-default" href="/weather.htm">Настройка погоды</a>
        <a class="btn btn-block btn-default" href="/narmon.htm">Настройка narodmon.ru</a>
        <a class="btn btn-block btn-default" href="/mqtt.htm">Настройка MQTT сервера</a>
        <a class="btn btn-block btn-default" href="/led.htm">Настройка дисплея</a>
        <a class="btn btn-block btn-default" href="/help.htm">Помощь</a>
        <input class="btn btn-block btn-danger" value="Перезагрузить устройство" onclick="restart(this,'Вы действительно желаете перезагрузить устройство?');" type="submit">
      </div>
    </div>  
  </div>
</body>
<head>
  <link rel="stylesheet" href="/bootstrap.min.css">
  <link rel="stylesheet" type="text/css" href="/style.css">
  <script type="text/javascript" src="/function.js"></script>
  <script type="text/javascript">
  var set_real_time;
  function set_updateOtta(submit){
    server = "/updateOtta?updateOTA="+val('updateOTA');
    send_request(submit,server);
  //  alert("Устройство будет перезагружено!");
  }
  function restart(submit,texts){
    if (confirm(texts)){
      server = "/restart?device=ok";
      send_request(submit,server);
      return true;
    } else {
      return false;
    }
  }
  </script>
</head>
)=====";
